package db

import (
	"github.com/go-xorm/xorm"
	"github.com/pkg/errors"
	"leit.com/leit_seat_aps/common"
	"xorm.io/core"
)

//EDI 文件子项表
type Edi_oem_itemlst struct {
	Finr          		int    `xorm:"pk" json:"edi_oem_itemlst.finr"`
	Ediid   			string `xorm:"pk" json:"edi_oem_itemlst.ediid"`
	Itemtype           	string `xorm:"pk" json:"edi_oem_itemlst.itemtype"`
	Itemid       		string `xorm:"pk" json:"edi_oem_itemlst.itemid"`
	Descr        		string `json:"edi_oem_itemlst.descr"`
	Pos           		int    `json:"edi_oem_itemlst.pos"`
	Keyval 				string `json:"edi_oem_itemlst.keyval"`
	Fileserver_host   	string `json:"edi_oem_itemlst.fileserver_host"`
	Inbox_folder        string `json:"edi_oem_itemlst.inbox_folder"`
	Lastmodif     		string `json:"edi_oem_itemlst.lastmodif"`
	Lastuser      		string `json:"edi_oem_itemlst.lastuser"`
	Credatuz      		string `json:"edi_oem_itemlst.credatuz"`
}

func (t *Edi_oem_itemlst) Clipped() {
	common.TrimStruct(t, *t)
}

func (t *Edi_oem_itemlst) TableName() string {
	return "edi_oem_itemlst"
}

//增
func (t *Edi_oem_itemlst) Add() error {
	e := G_DbEngine
	editab := new(Edi_oem_itemlst)
	affw, err := e.Table("edi_oem_itemlst").ID(core.PK{G_FINR, t.Ediid, t.Itemtype, t.Itemid}).Count(editab)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = e.Table("edi_oem_itemlst").Insert(t)

	if err != nil {
		return err
	}
	return nil
}

//增
func (t *Edi_oem_itemlst) Insert(session *xorm.Session) error {
	editab := new(Edi_oem_itemlst)
	affw, err := session.Table("edi_oem_itemlst").ID(core.PK{G_FINR, t.Ediid, t.Itemtype, t.Itemid}).Count(editab)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = session.Table("edi_oem_itemlst").Insert(t)

	if err != nil {
		return err
	}
	return nil
}

//删
func (t *Edi_oem_itemlst) Del() bool {
	e := G_DbEngine
	_, err := e.ID(core.PK{G_FINR, t.Ediid, t.Itemtype, t.Itemid}).Delete(&Edi_oem_itemlst{})
	if err != nil {
		return false
	}
	return true
}

//改
func (t *Edi_oem_itemlst) Update() bool {
	e := G_DbEngine
	_, err := e.ID(core.PK{G_FINR, t.Ediid, t.Itemtype, t.Itemid}).Update(t)
	if err != nil {
		return false
	}
	return true
}

//改
func (t *Edi_oem_itemlst) UpdateBySession(session *xorm.Session) bool {
	_, err := session.ID(core.PK{G_FINR, t.Ediid, t.Itemtype, t.Itemid}).Update(t)
	if err != nil {
		return false
	}
	return true
}

//更新指定字段
func (t *Edi_oem_itemlst) UpdateFields(session *xorm.Session, fields string) (err error) {
	if _, err = session.Table("edi_oem_itemlst").ID(core.PK{G_FINR, t.Ediid, t.Itemtype, t.Itemid}).Cols(fields).Update(t); err != nil {
		return
	}
	return
}

//查
func (t *Edi_oem_itemlst) SelectOne() (data Edi_oem_itemlst, err error) {
	e := G_DbEngine
	_, err = e.ID(core.PK{G_FINR, t.Ediid, t.Itemtype, t.Itemid}).Get(&data)
	if err != nil {
		return data, err
	}

	return data, nil
}
