package db

import (
	"github.com/go-xorm/xorm"
	"leit.com/leit_seat_aps/common"
	"xorm.io/core"
	"errors"
)

//Grammer 的ASN订单信息状态置位表
type Jit_asnorder_cache struct {
	Finr          int    `xorm:"pk" json:"jit_asnorder_cache.finr"`
	Asnnr         string `xorm:"pk" json:"jit_asnorder_cache.asnnr"`
	Partid        string `xorm:"pk" json:"jit_asnorder_cache.partid"`
	Ordernr       string `xorm:"pk" json:"jit_asnorder_cache.ordernr"`
	Oemordernr    string `json:"jit_asnorder_cache.oemordernr"`
	Shipqty       int    `json:"jit_asnorder_cache.shipqty"`
	Partfamilyid  string `json:"jit_asnorder_cache.partfamilyid"`
	Supplygroupid string `json:"jit_asnorder_cache.supplygroupid"`
	Swetyear      string `json:"jit_asnorder_cache.swetyear"`
	Flag          int    `json:"jit_asnorder_cache.flag"`
	Lastmodif     string `json:"jit_asnorder_cache.lastmodif"`
	Lastuser      string `json:"jit_asnorder_cache.lastuser"`
	Credatuz      string `json:"jit_asnorder_cache.credatuz"`
}

func (t *Jit_asnorder_cache) Clipped() {
	common.TrimStruct(t, *t)
}

func (t *Jit_asnorder_cache) TableName() string {
	return "jit_asnorder_cache"
}

//增
func (t *Jit_asnorder_cache) Add() (err error) {
	var (
		affw      int64
		asnordtab Jit_asnorder_cache
	)

	e := G_DbEngine
	asnordtab = Jit_asnorder_cache{}
	affw, err = e.Table("jit_asnorder_cache").ID(core.PK{G_FINR, t.Asnnr, t.Partid, t.Ordernr}).Count(asnordtab)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = e.Table("jit_asnorder_cache").Insert(t)
	if err != nil {
		return err
	}

	return nil
}

//增
func (t *Jit_asnorder_cache) Insert(session *xorm.Session) (err error) {
	var (
		affw      int64
		asnordtab Jit_asnorder_cache
	)

	asnordtab = Jit_asnorder_cache{}
	affw, err = session.Table("jit_asnorder_cache").ID(core.PK{G_FINR, t.Asnnr, t.Partid, t.Ordernr}).Count(asnordtab)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = session.Table("jit_asnorder_cache").Insert(t)
	if err != nil {
		return err
	}

	return nil
}

//删
func (t *Jit_asnorder_cache) Del() bool {
	e := G_DbEngine
	_, err := e.ID(core.PK{G_FINR, t.Asnnr, t.Partid, t.Ordernr}).Delete(&Jit_asnorder_cache{})
	if err != nil {
		return false
	}
	return true
}

//删
func (t *Jit_asnorder_cache) DelInfo() bool {
	e := G_DbEngine
	_, err := e.Table("jit_asnorder_cache").Where("finr = ? and flag = ?", G_FINR, 1).Delete(&Jit_asnorder_cache{})
	if err != nil {
		return false
	}
	return true
}

//改
func (t *Jit_asnorder_cache) Update() bool {
	e := G_DbEngine
	_, err := e.ID(core.PK{G_FINR, t.Asnnr, t.Partid, t.Ordernr}).Update(t)
	if err != nil {
		return false
	}
	return true
}

//查
func (t *Jit_asnorder_cache) SelectInfo() bool {
	var data Jit_asnorder_cache
	e := G_DbEngine
	ok, err := e.Table("jit_asnorder_cache").Where("finr = ? and asnnr = ? and flag = 0", G_FINR, t.Asnnr).Get(&data)
	if err != nil {
		return false
	}
	if ok {
		return false
	}
	return true
}

//更新指定字段
func (t *Jit_asnorder_cache) UpdateFields(session *xorm.Session, fields string) (err error) {
	if _, err = session.Table("jit_asnorder_cache").Where("finr = ? and asnnr = ? and oemordernr = ? and partfamilyid = ?",G_FINR,t.Asnnr,t.Oemordernr,t.Partfamilyid).Cols(fields).Update(t); err != nil {
		return
	}
	return
}
