package db

import (
	"errors"
	"github.com/go-xorm/xorm"
	"leit.com/leit_seat_aps/common"
	"xorm.io/core"
)

//Grammer 的ASN订单信息表
type Jit_asnorder_landing struct {
	Finr          int    `xorm:"pk" json:"jit_asnorder_landing.finr"`
	Asnnr         string `xorm:"pk" json:"jit_asnorder_landing.asnnr"`
	Partid        string `xorm:"pk" json:"jit_asnorder_landing.partid"`
	Ordernr       string `xorm:"pk" json:"jit_asnorder_landing.ordernr"`
	Oemordernr    string `json:"jit_asnorder_landing.oemordernr"`
	Shipqty       int    `json:"jit_asnorder_landing.shipqty"`
	Partfamilyid  string `json:"jit_asnorder_landing.partfamilyid"`
	Supplygroupid string `json:"jit_asnorder_landing.supplygroupid"`
	Swetyear      string `json:"jit_asnorder_landing.swetyear"`
	Lastmodif     string `json:"jit_asnorder_landing.lastmodif"`
	Lastuser      string `json:"jit_asnorder_landing.lastuser"`
	Credatuz      string `json:"jit_asnorder_landing.credatuz"`
}

func (t *Jit_asnorder_landing) Clipped() {
	common.TrimStruct(t, *t)
}

func (t *Jit_asnorder_landing) TableName() string {
	return "jit_asnorder_landing"
}

//增
func (t *Jit_asnorder_landing) Add() (err error) {
	var (
		affw      int64
		asnordtab Jit_asnorder_landing
	)

	e := G_DbEngine
	asnordtab = Jit_asnorder_landing{}
	affw, err = e.Table("jit_asnorder_landing").ID(core.PK{G_FINR, t.Asnnr, t.Partid, t.Ordernr}).Count(asnordtab)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = e.Table("jit_asnorder_landing").Insert(t)
	if err != nil {
		return err
	}

	return nil
}

//增
func (t *Jit_asnorder_landing) Insert(session *xorm.Session) (err error) {
	var (
		affw      int64
		asnordtab Jit_asnorder_landing
	)

	asnordtab = Jit_asnorder_landing{}
	affw, err = session.Table("jit_asnorder_landing").ID(core.PK{G_FINR, t.Asnnr, t.Partid, t.Ordernr}).Count(asnordtab)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = session.Table("jit_asnorder_landing").Insert(t)
	if err != nil {
		return err
	}

	return nil
}

//删
func (t *Jit_asnorder_landing) Del() bool {
	e := G_DbEngine
	_, err := e.ID(core.PK{G_FINR, t.Asnnr, t.Partid, t.Ordernr}).Delete(&Jit_asnorder_landing{})
	if err != nil {
		return false
	}
	return true
}

//改
func (t *Jit_asnorder_landing) Update() bool {
	e := G_DbEngine
	_, err := e.ID(core.PK{G_FINR, t.Asnnr, t.Partid, t.Ordernr}).Update(t)
	if err != nil {
		return false
	}
	return true
}

//更新指定字段
func (t *Jit_asnorder_landing) UpdateFields(session *xorm.Session, fields string) (err error) {
	if _, err = session.Table("jit_asnorder_landing").ID(core.PK{G_FINR, t.Asnnr, t.Partid, t.Ordernr}).Cols(fields).Update(t); err != nil {
		return
	}
	return
}
