package db

import (
	"errors"
	"github.com/go-xorm/xorm"
	"leit.com/leit_seat_aps/common"
	"xorm.io/core"
)

//BBA ASN 子项表
type Jit_bbaasn_itemlst struct {
	Finr          	int    	`xorm:"pk" json:"jit_bbaasn_itemlst.finr"`
	Asn   			string 	`xorm:"pk" json:"jit_bbaasn_itemlst.asn"`
	Pos           	int    	`xorm:"pk" json:"jit_bbaasn_itemlst.pos"`
	Calloffnr       int 	`json:"jit_bbaasn_itemlst.calloffnr"`
	Oemordernr      string 	`json:"jit_bbaasn_itemlst.oemordernr"`
	Partfamilyid    string 	`json:"jit_bbaasn_itemlst.partfamilyid"`
	Supplygroupid 	string 	`json:"jit_bbaasn_itemlst.supplygroupid"`
	Packorderid   	string 	`json:"jit_bbaasn_itemlst.packorderid"`
	Modelcode       string 	`json:"jit_bbaasn_itemlst.modelcode"`
	Swet       		string 	`json:"jit_bbaasn_itemlst.swet"`
	Binnr        	string 	`json:"jit_bbaasn_itemlst.binnr"`
	Lastmodif     	string 	`json:"jit_bbaasn_itemlst.lastmodif"`
	Lastuser      	string 	`json:"jit_bbaasn_itemlst.lastuser"`
	Credatuz      	string 	`json:"jit_bbaasn_itemlst.credatuz"`
}

func (t *Jit_bbaasn_itemlst) Clipped() {
	common.TrimStruct(t, *t)
}

func (t *Jit_bbaasn_itemlst) TableName() string {
	return "jit_bbaasn_itemlst"
}

//增
func (t *Jit_bbaasn_itemlst) Add() error {
	e := G_DbEngine
	asnitemtab := new(Jit_bbaasn_itemlst)
	affw, err := e.Table("jit_bbaasn_itemlst").ID(core.PK{G_FINR, t.Asn, t.Pos}).Count(asnitemtab)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = e.Table("jit_bbaasn_itemlst").Insert(t)

	if err != nil {
		return err
	}
	return nil
}

//增
func (t *Jit_bbaasn_itemlst) Insert(session *xorm.Session) error {
	asnitemtab := new(Jit_bbaasn_itemlst)
	affw, err := session.Table("jit_bbaasn_itemlst").ID(core.PK{G_FINR, t.Asn, t.Pos}).Count(asnitemtab)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = session.Table("jit_bbaasn_itemlst").Insert(t)

	if err != nil {
		return err
	}
	return nil
}

//删
func (t *Jit_bbaasn_itemlst) Del() bool {
	e := G_DbEngine
	_, err := e.ID(core.PK{G_FINR, t.Asn, t.Pos}).Delete(&Jit_bbaasn_itemlst{})
	if err != nil {
		return false
	}
	return true
}

//改
func (t *Jit_bbaasn_itemlst) Update() bool {
	e := G_DbEngine
	_, err := e.ID(core.PK{G_FINR, t.Asn, t.Pos}).Update(t)
	if err != nil {
		return false
	}
	return true
}

//改
func (t *Jit_bbaasn_itemlst) UpdateBySession(session *xorm.Session) bool {
	_, err := session.ID(core.PK{G_FINR, t.Asn, t.Pos}).Update(t)
	if err != nil {
		return false
	}
	return true
}

//更新指定字段
func (t *Jit_bbaasn_itemlst) UpdateFields(session *xorm.Session, fields string) (err error) {
	if _, err = session.Table("jit_bbaasn_itemlst").ID(core.PK{G_FINR, t.Asn, t.Pos}).Cols(fields).Update(t); err != nil {
		return
	}
	return
}

//查
func (t *Jit_bbaasn_itemlst) SelectOne() (data Jit_bbaasn_itemlst, err error) {
	e := G_DbEngine
	_, err = e.ID(core.PK{G_FINR, t.Asn, t.Pos}).Get(&data)
	if err != nil {
		return data, err
	}

	return data, nil
}
