package db

import (
	"errors"
	"github.com/go-xorm/xorm"
	"leit.com/leit_seat_aps/common"
	"xorm.io/core"
)

//发运包装模板子项表
type Jit_packtemplate_itemlst struct {
	Finr           int    `xorm:"pk"`
	Packtemplateid string `xorm:"pk"`
	Pos            int    `xorm:"pk"`
	Poscode        string
	Supplygroupid  string
	Seq            int
	Planqty        int
	Lastmodif      string
	Lastuser       string
	Credatuz       string
}

func (t *Jit_packtemplate_itemlst) Clipped() {
	common.TrimStruct(t, *t)
}

func (t *Jit_packtemplate_itemlst) TableName() string {
	return "jit_packtemplate_itemlst"
}

//增
func (t *Jit_packtemplate_itemlst) Add() error {
	e := G_DbEngine
	pktmpitemtab := new(Jit_packtemplate_itemlst)
	affw, err := e.Table("jit_packorder_itemlst").ID(core.PK{G_FINR, t.Packtemplateid, t.Pos}).Count(pktmpitemtab)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = e.Table("jit_packtemplate_itemlst").Insert(t)

	if err != nil {
		return err
	}
	return nil
}

//增
func (t *Jit_packtemplate_itemlst) Insert(session *xorm.Session) error {
	pktmpitemtab := new(Jit_packtemplate_itemlst)
	affw, err := session.Table("jit_packtemplate_itemlst").ID(core.PK{G_FINR, t.Packtemplateid, t.Pos}).Count(pktmpitemtab)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = session.Table("jit_packtemplate_itemlst").Insert(t)

	if err != nil {
		return err
	}
	return nil
}

//删
func (t *Jit_packtemplate_itemlst) Del() bool {
	e := G_DbEngine
	_, err := e.ID(core.PK{G_FINR, t.Packtemplateid, t.Pos}).Delete(&Jit_packtemplate_itemlst{})
	if err != nil {
		return false
	}
	return true
}

//改
func (t *Jit_packtemplate_itemlst) Update() bool {
	e := G_DbEngine
	_, err := e.ID(core.PK{G_FINR, t.Packtemplateid, t.Pos}).Update(t)
	if err != nil {
		return false
	}
	return true
}

//更新指定字段
func (t *Jit_packtemplate_itemlst) UpdateFields(session *xorm.Session, fields string) (err error) {
	if _, err = session.Table("jit_packtemplate_itemlst").ID(core.PK{G_FINR, t.Packtemplateid, t.Pos}).Cols(fields).Update(t); err != nil {
		return
	}
	return
}

//查
func (t *Jit_packtemplate_itemlst) SelectOne() (data Jit_packtemplate_itemlst, err error) {
	e := G_DbEngine
	_, err = e.ID(core.PK{G_FINR, t.Packtemplateid, t.Pos}).Get(&data)
	if err != nil {
		return data, err
	}

	return data, nil
}
