package db

import (
	"errors"
	"github.com/go-xorm/xorm"
	"leit.com/leit_seat_aps/common"
	"xorm.io/core"
)

//发运包装单子项表
type Jit_shiporder_datalst struct {
	Finr        int    `xorm:"pk"`
	Shiporderid string `xorm:"pk"`
	Packtypeid  string `xorm:"pk"`
	Packorderid string `xorm:"pk"`
	Status      int
	Planqty     int
	Actqty      int
	Lastmodif   string
	Lastuser    string
	Credatuz    string
}

func (t *Jit_shiporder_datalst) Clipped() {
	common.TrimStruct(t, *t)
}

func (t *Jit_shiporder_datalst) TableName() string {
	return "jit_shiporder_datalst"
}

//增
func (t *Jit_shiporder_datalst) Add() error {
	e := G_DbEngine
	spodatatab := new(Jit_shiporder_datalst)
	affw, err := e.Table("jit_shiporder_datalst").ID(core.PK{G_FINR, t.Shiporderid, t.Packtypeid, t.Packorderid}).Count(spodatatab)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = e.Table("jit_shiporder_datalst").Insert(t)

	if err != nil {
		return err
	}
	return nil
}

//增
func (t *Jit_shiporder_datalst) Insert(session *xorm.Session) error {
	spodatatab := new(Jit_shiporder_datalst)
	affw, err := session.Table("jit_shiporder_datalst").ID(core.PK{G_FINR, t.Shiporderid, t.Packtypeid, t.Packorderid}).Count(spodatatab)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = session.Table("jit_shiporder_datalst").Insert(t)

	if err != nil {
		return err
	}
	return nil
}

//删
func (t *Jit_shiporder_datalst) Del() bool {
	e := G_DbEngine
	_, err := e.ID(core.PK{G_FINR, t.Shiporderid, t.Packtypeid, t.Packorderid}).Delete(&Jit_shiporder_datalst{})
	if err != nil {
		return false
	}
	return true
}

//改
func (t *Jit_shiporder_datalst) Update() bool {
	e := G_DbEngine
	_, err := e.ID(core.PK{G_FINR, t.Shiporderid, t.Packtypeid, t.Packorderid}).Update(t)
	if err != nil {
		return false
	}
	return true
}

//改
func (t *Jit_shiporder_datalst) UpdateBySession(session *xorm.Session) bool {
	_, err := session.ID(core.PK{G_FINR, t.Shiporderid, t.Packtypeid, t.Packorderid}).Update(t)
	if err != nil {
		return false
	}
	return true
}

//更新指定字段
func (t *Jit_shiporder_datalst) UpdateFields(session *xorm.Session, fields string) (err error) {
	if _, err = session.Table("jit_shiporder_datalst").ID(core.PK{G_FINR, t.Shiporderid, t.Packtypeid, t.Packorderid}).Cols(fields).Update(t); err != nil {
		return
	}
	return
}

//查
func (t *Jit_shiporder_datalst) SelectOne() (data Jit_shiporder_datalst, err error) {
	e := G_DbEngine
	_, err = e.ID(core.PK{G_FINR, t.Shiporderid, t.Packtypeid, t.Packorderid}).Get(&data)
	if err != nil {
		return data, err
	}

	return data, nil
}
