package db

import (
	"errors"
	"github.com/go-xorm/xorm"
	"leit.com/leit_seat_aps/common"
	"xorm.io/core"
)

//发运包装单子项表
type Jit_shiporder_itemlst struct {
	Finr         int                     `xorm:"pk" json:"jit_shiporder_itemlst.finr"`
	Shiporderid  string                  `xorm:"pk" json:"jit_shiporder_itemlst.shiporderid"`
	Packtypeid   string                  `xorm:"pk" json:"jit_shiporder_itemlst.packtypeid"`
	Status       int                     `json:"jit_shiporder_itemlst.status"`
	Pos          int                     `json:"jit_shiporder_itemlst.pos"`
	Fillqty      int                     `json:"jit_shiporder_itemlst.fillqty"`
	Planqty      int                     `json:"jit_shiporder_itemlst.planqty"`
	Actqty       int                     `json:"jit_shiporder_itemlst.actqty"`
	Shortship    int                     `json:"jit_shiporder_itemlst.shortship"`
	Shortshipqty int                     `json:"jit_shiporder_itemlst.shortshipqty"`
	Shortby      string                  `json:"jit_shiporder_itemlst.shortby"`
	Shorttime    string                  `json:"jit_shiporder_itemlst.shorttime"`
	Lastmodif    string                  `json:"jit_shiporder_itemlst.lastmodif"`
	Lastuser     string                  `json:"jit_shiporder_itemlst.lastuser"`
	Credatuz     string                  `json:"jit_shiporder_itemlst.credatuz"`
	Itemlst      []Jit_shiporder_datalst `json:"itemlst" xorm:"-"`
}

func (t *Jit_shiporder_itemlst) Clipped() {
	common.TrimStruct(t, *t)
}

func (t *Jit_shiporder_itemlst) TableName() string {
	return "jit_shiporder_itemlst"
}

//增
func (t *Jit_shiporder_itemlst) Add() error {
	e := G_DbEngine
	spoitemtab := new(Jit_shiporder_itemlst)
	affw, err := e.Table("jit_shiporder_itemlst").ID(core.PK{G_FINR, t.Shiporderid, t.Packtypeid}).Count(spoitemtab)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = e.Table("jit_shiporder_itemlst").Insert(t)

	if err != nil {
		return err
	}
	return nil
}

//增
func (t *Jit_shiporder_itemlst) Insert(session *xorm.Session) error {
	spoitemtab := new(Jit_shiporder_itemlst)
	affw, err := session.Table("jit_shiporder_itemlst").ID(core.PK{G_FINR, t.Shiporderid, t.Packtypeid}).Count(spoitemtab)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = session.Table("jit_shiporder_itemlst").Insert(t)

	if err != nil {
		return err
	}
	return nil
}

//删
func (t *Jit_shiporder_itemlst) Del() bool {
	e := G_DbEngine
	_, err := e.ID(core.PK{G_FINR, t.Shiporderid, t.Packtypeid}).Delete(&Jit_shiporder_itemlst{})
	if err != nil {
		return false
	}
	return true
}

//改
func (t *Jit_shiporder_itemlst) Update() bool {
	e := G_DbEngine
	_, err := e.ID(core.PK{G_FINR, t.Shiporderid, t.Packtypeid}).Update(t)
	if err != nil {
		return false
	}
	return true
}

//改
func (t *Jit_shiporder_itemlst) UpdateBySession(session *xorm.Session) bool {
	_, err := session.ID(core.PK{G_FINR, t.Shiporderid, t.Packtypeid}).Update(t)
	if err != nil {
		return false
	}
	return true
}

//更新指定字段
func (t *Jit_shiporder_itemlst) UpdateFields(session *xorm.Session, fields string) (err error) {
	if _, err = session.Table("jit_shiporder_itemlst").ID(core.PK{G_FINR, t.Shiporderid, t.Packtypeid}).Cols(fields).Update(t); err != nil {
		return
	}
	return
}

//查
func (t *Jit_shiporder_itemlst) SelectOne() (data Jit_shiporder_itemlst, err error) {
	var i int

	e := G_DbEngine
	_, err = e.ID(core.PK{G_FINR, t.Shiporderid, t.Packtypeid}).Get(&data)
	if err != nil {
		return data, err
	}

	// 获取值列表
	if err = e.Where("finr = ? and shiporderid = ? and packtypeid = ?",
		G_FINR, data.Shiporderid, data.Packtypeid).OrderBy("packorderid").Find(&data.Itemlst); err != nil {
		return
	}
	for i, _ = range data.Itemlst {
		data.Itemlst[i].Clipped()
	}

	return data, nil
}

//查
func (t *Jit_shiporder_itemlst) SelectOneBySession(session *xorm.Session) (data Jit_shiporder_itemlst, err error) {
	var i int

	_, err = session.ID(core.PK{G_FINR, t.Shiporderid, t.Packtypeid}).Get(&data)
	if err != nil {
		return data, err
	}

	// 获取值列表
	if err = session.Where("finr = ? and shiporderid = ? and packtypeid = ?",
		G_FINR, data.Shiporderid, data.Packtypeid).OrderBy("packorderid").Find(&data.Itemlst); err != nil {
		return
	}
	for i, _ = range data.Itemlst {
		data.Itemlst[i].Clipped()
	}

	return data, nil
}
