package db

import (
	"errors"
	"github.com/go-xorm/xorm"
	"leit.com/leit_seat_aps/common"
	"xorm.io/core"
)

// 车型版本属性清单
type Me_carmodel_ver_atcodlst struct {
	Finr       int    `xorm:"pk"`
	Carmodelid string `xorm:"pk"`
	Version    int    `xorm:"pk"`
	Pos        int    `xorm:"pk"`
	Attrcode   int
	Attrvalue  string
	Lastmodif  string
	Lastuser   string
	Credatuz   string
}

func (t *Me_carmodel_ver_atcodlst) Clipped() {
	common.TrimStruct(t, *t)
}

func (t *Me_carmodel_ver_atcodlst) TableName() string {
	return "me_carmodel_ver_atcodlst"
}

//增
func (t *Me_carmodel_ver_atcodlst) Add() error {
	e := G_DbEngine
	carmodatcodtab := new(Me_carmodel_ver_atcodlst)
	affw, err := e.Table("me_carmodel_ver_atcodlst").ID(core.PK{G_FINR, t.Carmodelid, t.Version, t.Pos}).Count(carmodatcodtab)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = e.Table("me_carmodel_ver_atcodlst").Insert(t)

	if err != nil {
		return err
	}
	return nil
}

//增
func (t *Me_carmodel_ver_atcodlst) Insert(session *xorm.Session) error {
	carmodatcodtab := new(Me_carmodel_ver_atcodlst)
	affw, err := session.Table("me_carmodel_ver_atcodlst").ID(core.PK{G_FINR, t.Carmodelid, t.Version, t.Pos}).Count(carmodatcodtab)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = session.Table("me_carmodel_ver_atcodlst").Insert(t)

	if err != nil {
		return err
	}
	return nil
}

//删
func (t *Me_carmodel_ver_atcodlst) Del() bool {
	e := G_DbEngine
	_, err := e.ID(core.PK{G_FINR, t.Carmodelid, t.Version, t.Pos}).Delete(&Me_carmodel_ver_atcodlst{})
	if err != nil {
		return false
	}
	return true
}

//改
func (t *Me_carmodel_ver_atcodlst) Update() bool {
	e := G_DbEngine
	_, err := e.ID(core.PK{G_FINR, t.Carmodelid, t.Version, t.Pos}).Update(t)
	if err != nil {
		return false
	}
	return true
}

//查
func (t *Me_carmodel_ver_atcodlst) SelectOne() (data Me_carmodel_ver_atcodlst, err error) {

	e := G_DbEngine
	_, err = e.ID(core.PK{G_FINR, t.Carmodelid, t.Version, t.Pos}).Get(&data)
	if err != nil {
		return data, err
	}
	data.Clipped()

	return data, nil
}
