package db

import (
	"errors"
	"leit.com/leit_seat_aps/common"
	"xorm.io/core"
)

//零件族
type Me_partfamily struct {
	Finr         int    `xorm:"pk"`
	Partfamilyid string `xorm:"pk"`
	Projnr       string
	Descr        string
	Pf_cust1     string
	Pf_cust2     string
	Pf_cust3     string
	Pf_cust4     string
	Lastmodif    string
	Lastuser     string
	Credatuz     string
	Atcodlst     []Me_partfamily_atcodlst `xorm:"-"`
}

func (t *Me_partfamily) Clipped() {
	common.TrimStruct(t, *t)
}

func (t *Me_partfamily) TableName() string {
	return "me_partfamily"
}

//增
func (t *Me_partfamily) Add() error {
	e := G_DbEngine
	pftab := new(Me_partfamily)
	affw, err := e.Table("me_partfamily").ID(core.PK{G_FINR, t.Partfamilyid}).Count(pftab)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = e.Table("me_partfamily").Insert(t)

	if err != nil {
		return err
	}
	return nil
}

//删
func (t *Me_partfamily) Del() bool {
	e := G_DbEngine
	_, err := e.ID(core.PK{G_FINR, t.Partfamilyid}).Delete(&Me_partfamily{})
	if err != nil {
		return false
	}
	return true
}

//改
func (t *Me_partfamily) Update() bool {
	e := G_DbEngine
	_, err := e.ID(core.PK{G_FINR, t.Partfamilyid}).Update(t)
	if err != nil {
		return false
	}
	return true
}

//查
func (t *Me_partfamily) SelectOne() (data Me_partfamily, err error) {
	var atcodlst []Me_partfamily_atcodlst

	e := G_DbEngine
	_, err = e.ID(core.PK{G_FINR, t.Partfamilyid}).Get(&data)
	if err != nil {
		return data, err
	}
	data.Clipped()

	// 获取值列表
	if err = e.Where("finr = ? and partfamilyid = ?", G_FINR, t.Partfamilyid).OrderBy("attrcode").Find(&atcodlst); err != nil {
		return
	}
	for i, _ := range atcodlst {
		atcodlst[i].Clipped()
	}
	data.Atcodlst = atcodlst
	return data, nil
}

// 获取指定项目的零件族列表
func (t *Me_partfamily) GetProjectAll(projnr string) (datalst []Me_partfamily, err error) {
	var i, j int

	e := G_DbEngine
	if err = e.Where("finr = ? and projnr = ?", G_FINR, projnr).OrderBy("partfamilyid").Find(&datalst); err != nil {
		return
	}

	// 遍历零件族获取属性列表
	for i, _ = range datalst {
		datalst[i].Clipped()
		datalst[i].Atcodlst = []Me_partfamily_atcodlst{}
		// 获取值列表
		if err = e.Where("finr = ? and partfamilyid = ?", G_FINR, datalst[i].Partfamilyid).OrderBy("attrcode").Find(&datalst[i].Atcodlst); err != nil {
			return
		}
		for j, _ = range datalst[i].Atcodlst {
			datalst[i].Atcodlst[j].Clipped()
		}
	}
	return
}

// 获取指定项目的零件族列表
func (t *Me_partfamily) GetProjectPfList(projnr string) (datalst []Me_partfamily, err error) {
	e := G_DbEngine
	if err = e.Where("finr = ? and projnr = ?", G_FINR, projnr).OrderBy("partfamilyid").Find(&datalst); err != nil {
		return
	}

	return
}
