// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.
package db

import (
	uuid "github.com/iris-contrib/go.uuid"
	"leit.com/leit_seat_aps/common"
)

type Pln_custorder_archive_error struct {
	Id        string `xorm:"not null pk comment('车间编号') VARCHAR(18)" json:"id"`
	Tablename string `xorm:"not null comment('表名') VARCHAR(18)" json:"tablename"`
	Errorinfo string `xorm:"not null comment('结束状态') VARCHAR(255)" json:"errorinfo"`
	Lastmodif string `xorm:"not null comment('上一次更改日期') VARCHAR(14)" json:"lastmodif"`
	Lastuser  string `xorm:"not null comment('最后编辑人员') VARCHAR(20)" json:"lastuser"`
	Credatuz  string `xorm:"not null comment('创建时间') VARCHAR(14)" json:"credatuz"`
}

func (t *Pln_custorder_archive_error) TableName() string {
	return "pln_custorder_archive_error"
}

// 清除string字段的右侧空格
func (t *Pln_custorder_archive_error) Clipped() {
	common.TrimStruct(t, *t)
}

/******************************************************************************
 *
 * @Function Name      :
 *-----------------------------------------------------------------------------
 *
 * @Description        :
 *
 * @Function Parameters:
 *
 * @Return Value       :
 *
 * @Author             : Lou Wenzhi
 *
 * @Date               : 2021/3/17 14:17
 *
 ******************************************************************************/
func (t *Pln_custorder_archive_error) Add() error {
	e := G_DbEngine
	info := new(Pln_custorder_archive_error)
	uuid, _ := uuid.NewV1()
	info.Id = uuid.String()
	info.Errorinfo = t.Errorinfo
	info.Tablename = t.Tablename
	_, err := e.Table("pln_custorder_archive").Insert(info)
	if err != nil {
		return err
	}
	return nil
}
