package db

import (
	"errors"
	"github.com/go-xorm/xorm"
	"leit.com/leit_seat_aps/common"
	"xorm.io/core"
)

//客户订单原始的基于SupplyGroup的零件清单表
type Pln_custorder_supplygroup_partlst struct {
	Finr          int    `xorm:"pk"`
	Custordernr   string `xorm:"pk"`
	Supplygroupid string `xorm:"pk"`
	Partid        string `xorm:"pk"`
	Partfamilyid  string
	Partqty       int
	Lastmodif     string
	Lastuser      string
	Credatuz      string
}

func (t *Pln_custorder_supplygroup_partlst) Clipped() {
	common.TrimStruct(t, *t)
}

func (t *Pln_custorder_supplygroup_partlst) TableName() string {
	return "pln_custorder_supplygroup_partlst"
}

//共用件
type CustorderSupplyPartlst struct {
	Pln_custorder_supplygroup_partlst `xorm:"extends"`
	Me_supplygroup                    `xorm:"extends"`
	Pln_custorder                     `xorm:"extends"`
}

//增
func (t *Pln_custorder_supplygroup_partlst) Add() error {
	e := G_DbEngine
	cosgpttab := new(Pln_custorder_supplygroup_partlst)
	affw, err := e.Table("pln_custorder_supplygroup_partlst").ID(core.PK{G_FINR, t.Custordernr, t.Supplygroupid, t.Partid}).Count(cosgpttab)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = e.Table("pln_custorder_supplygroup_partlst").Insert(t)

	if err != nil {
		return err
	}
	return nil
}

//增
func (t *Pln_custorder_supplygroup_partlst) Insert(session *xorm.Session) error {
	cosgpttab := new(Pln_custorder_supplygroup_partlst)
	affw, err := session.Table("pln_custorder_supplygroup_partlst").ID(core.PK{G_FINR, t.Custordernr, t.Supplygroupid, t.Partid}).Count(cosgpttab)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = session.Table("pln_custorder_supplygroup_partlst").Insert(t)

	if err != nil {
		return err
	}
	return nil
}

//删
func (t *Pln_custorder_supplygroup_partlst) Del() bool {
	e := G_DbEngine
	_, err := e.ID(core.PK{G_FINR, t.Custordernr, t.Supplygroupid, t.Partid}).Delete(&Pln_custorder_supplygroup_partlst{})
	if err != nil {
		return false
	}
	return true
}

//改
func (t *Pln_custorder_supplygroup_partlst) Update() bool {
	e := G_DbEngine
	_, err := e.ID(core.PK{G_FINR, t.Custordernr, t.Supplygroupid, t.Partid}).Update(t)
	if err != nil {
		return false
	}
	return true
}

//查
func (t *Pln_custorder_supplygroup_partlst) SelectOne() (data Pln_custorder_supplygroup_partlst, err error) {
	e := G_DbEngine
	_, err = e.ID(core.PK{G_FINR, t.Custordernr, t.Supplygroupid, t.Partid}).Get(&data)
	if err != nil {
		return data, err
	}
	return data, nil
}
