package db

import (
	"errors"
	"github.com/go-xorm/xorm"
	"leit.com/leit_seat_aps/common"
	"xorm.io/core"
)

//客户订单版本零件清单表
type Pln_custorder_ver_partlst struct {
	Finr          int    `xorm:"pk"`
	Custordernr   string `xorm:"pk"`
	Version       int    `xorm:"pk"`
	Supplygroupid string `xorm:"pk"`
	Partid        string `xorm:"pk"`
	Partqty       int
	Lastmodif     string
	Lastuser      string
	Credatuz      string
}

func (t *Pln_custorder_ver_partlst) Clipped() {
	common.TrimStruct(t, *t)
}

func (t *Pln_custorder_ver_partlst) TableName() string {
	return "pln_custorder_ver_partlst"
}

//增
func (t *Pln_custorder_ver_partlst) Add() error {
	e := G_DbEngine
	covptab := new(Pln_custorder_ver_partlst)
	affw, err := e.Table("pln_custorder_ver_partlst").ID(core.PK{G_FINR, t.Custordernr, t.Version, t.Supplygroupid, t.Partid}).Count(covptab)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = e.Table("pln_custorder_ver_partlst").Insert(t)

	if err != nil {
		return err
	}
	return nil
}

//增
func (t *Pln_custorder_ver_partlst) Insert(session *xorm.Session) error {
	covptab := new(Pln_custorder_ver_partlst)
	affw, err := session.Table("pln_custorder_ver_partlst").ID(core.PK{G_FINR, t.Custordernr, t.Version, t.Supplygroupid, t.Partid}).Count(covptab)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = session.Table("pln_custorder_ver_partlst").Insert(t)

	if err != nil {
		return err
	}
	return nil
}

//删
func (t *Pln_custorder_ver_partlst) DelSession(session *xorm.Session) bool {
	_, err := session.ID(core.PK{G_FINR, t.Custordernr, t.Version, t.Supplygroupid, t.Partid}).Delete(&Pln_custorder_ver_partlst{})
	if err != nil {
		return false
	}
	return true
}

//删
func (t *Pln_custorder_ver_partlst) Del() bool {
	e := G_DbEngine
	_, err := e.ID(core.PK{G_FINR, t.Custordernr, t.Version, t.Supplygroupid, t.Partid}).Delete(&Pln_custorder_ver_partlst{})
	if err != nil {
		return false
	}
	return true
}

//改
func (t *Pln_custorder_ver_partlst) Update() bool {
	e := G_DbEngine
	_, err := e.ID(core.PK{G_FINR, t.Custordernr, t.Version, t.Supplygroupid, t.Partid}).Update(t)
	if err != nil {
		return false
	}
	return true
}

//查
func (t *Pln_custorder_ver_partlst) SelectOne() (data Pln_custorder_ver_partlst, err error) {
	e := G_DbEngine
	_, err = e.ID(core.PK{G_FINR, t.Custordernr, t.Version, t.Supplygroupid, t.Partid}).Get(&data)
	if err != nil {
		return data, err
	}
	data.Clipped()

	return data, nil
}
