package db

import (
	"errors"
	"github.com/go-xorm/xorm"
	"leit.com/leit_seat_aps/common"
	"xorm.io/core"
)

//拣料单项
type Pln_pickorder_itemlst struct {
	Finr        int     `xorm:"pk" json:"pln_pickorder_itemlst.finr"`
	Pickorderid string  `xorm:"pk" json:"pln_pickorder_itemlst.pickorderid"`
	Pos         int     `xorm:"pk" json:"pln_pickorder_itemlst.pos"`
	Partid      string  `json:"pln_pickorder_itemlst.partid"`
	Descr1      string  `json:"pln_pickorder_itemlst.descr1"`
	Descr2      string  `json:"pln_pickorder_itemlst.descr2"`
	Attrcode    int     `json:"pln_pickorder_itemlst.attrcode"`
	Serialno    string  `json:"pln_pickorder_itemlst.serialno"`
	Planqty     int     `json:"pln_pickorder_itemlst.planqty"`
	Fillqty     int     `json:"pln_pickorder_itemlst.fillqty"`
	Actqty      int     `json:"pln_pickorder_itemlst.actqty"`
	Status      int     `json:"pln_pickorder_itemlst.status"`
	Oemseq      float64 `json:"pln_pickorder_itemlst.oemseq"`
	Lastmodif   string  `json:"pln_pickorder_itemlst.lastmodif"`
	Lastuser    string  `json:"pln_pickorder_itemlst.lastuser"`
	Credatuz    string  `json:"pln_pickorder_itemlst.credatuz"`
}

func (t *Pln_pickorder_itemlst) Clipped() {
	common.TrimStruct(t, *t)
}

func (t *Pln_pickorder_itemlst) TableName() string {
	return "pln_pickorder_itemlst"
}

//增
func (t *Pln_pickorder_itemlst) Add() error {
	e := G_DbEngine
	pikoitemtab := new(Pln_pickorder_itemlst)
	affw, err := e.Table("pln_pickorder_itemlst").ID(core.PK{G_FINR, t.Pickorderid, t.Pos}).Count(pikoitemtab)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = e.Table("pln_pickorder_itemlst").Insert(t)

	if err != nil {
		return err
	}
	return nil
}

//增
func (t *Pln_pickorder_itemlst) Insert(session *xorm.Session) error {
	pikoitemtab := new(Pln_pickorder_itemlst)
	affw, err := session.Table("pln_pickorder_itemlst").ID(core.PK{G_FINR, t.Pickorderid, t.Pos}).Count(pikoitemtab)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = session.Table("pln_pickorder_itemlst").Insert(t)

	if err != nil {
		return err
	}
	return nil
}

//删
func (t *Pln_pickorder_itemlst) Del() bool {
	e := G_DbEngine
	_, err := e.ID(core.PK{G_FINR, t.Pickorderid, t.Pos}).Delete(&Pln_pickorder_itemlst{})
	if err != nil {
		return false
	}
	return true
}

//改
func (t *Pln_pickorder_itemlst) Update() bool {
	e := G_DbEngine
	_, err := e.ID(core.PK{G_FINR, t.Pickorderid, t.Pos}).Update(t)
	if err != nil {
		return false
	}
	return true
}

//更新指定字段
func (t *Pln_pickorder_itemlst) UpdateFields(session *xorm.Session, fields string) (err error) {
	if _, err = session.ID(core.PK{G_FINR, t.Pickorderid, t.Pos}).Cols(fields).Update(t); err != nil {
		return
	}
	return
}
