package db

import (
	"errors"
	"github.com/go-xorm/xorm"
	"leit.com/leit_seat_aps/common"
	"xorm.io/core"
)

// 拣料单打印设置表
type Pln_picktemplate_printlst struct {
	Finr           int    `xorm:"pk"`
	Picktemplateid string `xorm:"pk"`
	Pos            int    `xorm:"pk"`
	Varname        string
	Varvalue       string
	Vartype        string
	Varpos         string
	Picture        string
	Isidx          int
	Keyval         string
	Lastmodif      string
	Lastuser       string
	Credatuz       string
}

func (t *Pln_picktemplate_printlst) Clipped() {
	common.TrimStruct(t, *t)
}
func (t *Pln_picktemplate_printlst) TableName() string {
	return "pln_picktemplate_printlst"
}

//增
func (t *Pln_picktemplate_printlst) Add() error {
	e := G_DbEngine
	ptprinttab := new(Pln_picktemplate_printlst)
	affw, err := e.Table("pln_picktemplate_printlst").ID(core.PK{G_FINR, t.Picktemplateid, t.Pos}).Count(ptprinttab)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = e.Table("pln_picktemplate_printlst").Insert(t)

	if err != nil {
		return err
	}
	return nil
}

//增
func (t *Pln_picktemplate_printlst) Insert(session *xorm.Session) error {
	ptprinttab := new(Pln_picktemplate_printlst)
	affw, err := session.Table("pln_picktemplate_printlst").ID(core.PK{G_FINR, t.Picktemplateid, t.Pos}).Count(ptprinttab)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = session.Table("pln_picktemplate_printlst").Insert(t)

	if err != nil {
		return err
	}
	return nil
}

//删
func (t *Pln_picktemplate_printlst) Del() bool {
	e := G_DbEngine
	_, err := e.ID(core.PK{G_FINR, t.Picktemplateid, t.Pos}).Delete(&Pln_picktemplate_printlst{})
	if err != nil {
		return false
	}
	return true
}

//改
func (t *Pln_picktemplate_printlst) Update() bool {
	e := G_DbEngine
	_, err := e.ID(core.PK{G_FINR, t.Picktemplateid, t.Pos}).Update(t)
	if err != nil {
		return false
	}
	return true
}

//更新指定字段
func (t *Pln_picktemplate_printlst) UpdateFields(session *xorm.Session, fields string) (err error) {
	if _, err = session.Table("pln_picktemplate_printlst").ID(core.PK{G_FINR, t.Picktemplateid, t.Pos}).Cols(fields).Update(t); err != nil {
		return
	}
	return
}

//查
func (t *Pln_picktemplate_printlst) SelectOne() (data Pln_picktemplate_printlst, err error) {
	e := G_DbEngine
	_, err = e.ID(core.PK{G_FINR, t.Picktemplateid, t.Pos}).Get(&data)
	if err != nil {
		return data, err
	}
	data.Clipped()
	return data, nil
}
