package db

import (
	"errors"
	"github.com/go-xorm/xorm"
	"leit.com/leit_seat_aps/common"
	"xorm.io/core"
)

//Reorder头信息表
type Pln_reorderpart_landing struct {
	Finr          int    `xorm:"pk"`
	Reordernr     string `xorm:"pk"`
	Oemordernr    string `xorm:"pk"`
	Supplygroupid string `xorm:"pk"`
	Partid        string `xorm:"pk"`
	Partqty       int
	Lastmodif     string
	Lastuser      string
	Credatuz      string
}

func (t *Pln_reorderpart_landing) Clipped() {
	common.TrimStruct(t, *t)
}
func (t *Pln_reorderpart_landing) TableName() string {
	return "pln_reorderpart_landing"
}

//增
func (t *Pln_reorderpart_landing) Add() error {
	e := G_DbEngine
	reordparttab := new(Pln_reorderpart_landing)
	affw, err := e.Table("pln_reorderpart_landing").ID(core.PK{G_FINR, t.Reordernr, t.Oemordernr, t.Supplygroupid, t.Partid}).Count(reordparttab)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = e.Table("pln_reorderpart_landing").Insert(t)

	if err != nil {
		return err
	}
	return nil
}

//增
func (t *Pln_reorderpart_landing) Insert(session *xorm.Session) error {
	reordparttab := new(Pln_reorderpart_landing)
	affw, err := session.Table("pln_reorderpart_landing").ID(core.PK{G_FINR, t.Reordernr, t.Oemordernr, t.Supplygroupid, t.Partid}).Count(reordparttab)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = session.Table("pln_reorderpart_landing").Insert(t)

	if err != nil {
		return err
	}
	return nil
}

//删
func (t *Pln_reorderpart_landing) Del() bool {
	e := G_DbEngine
	_, err := e.ID(core.PK{G_FINR, t.Reordernr, t.Oemordernr, t.Supplygroupid, t.Partid}).Delete(&Pln_reorderpart_landing{})
	if err != nil {
		return false
	}
	return true
}

//改
func (t *Pln_reorderpart_landing) Update() bool {
	e := G_DbEngine
	_, err := e.ID(core.PK{G_FINR, t.Reordernr, t.Oemordernr, t.Supplygroupid, t.Partid}).Update(t)
	if err != nil {
		return false
	}
	return true
}

//更新指定字段
func (t *Pln_reorderpart_landing) UpdateFields(session *xorm.Session, fields string) (err error) {
	if _, err = session.Table("pln_reorderpart_landing").ID(core.PK{G_FINR, t.Reordernr, t.Oemordernr, t.Supplygroupid, t.Partid}).Cols(fields).Update(t); err != nil {
		return
	}
	return
}
