package db

import (
	"errors"
	"github.com/go-xorm/xorm"
	"leit.com/leit_seat_aps/common"
	"xorm.io/core"
)

//生产订单零件清单表
type Pln_workorder_partlst struct {
	Finr        int    `xorm:"pk" json:"pln_workorder_partlst.finr"`
	Workordernr string `xorm:"pk" json:"pln_workorder_partlst.workordernr"`
	Partid      string `xorm:"pk" json:"pln_workorder_partlst.partid"`
	Partqty     int    `json:"pln_workorder_partlst.partqty"`
	Lastmodif   string `json:"pln_workorder_partlst.lastmodif"`
	Lastuser    string `json:"pln_workorder_partlst.lastuser"`
	Credatuz    string `json:"pln_workorder_partlst.credatuz"`
}

func (t *Pln_workorder_partlst) Clipped() {
	common.TrimStruct(t, *t)
}

func (t *Pln_workorder_partlst) TableName() string {
	return "pln_workorder_partlst"
}

//增
func (t *Pln_workorder_partlst) Add() error {
	e := G_DbEngine
	woptab := new(Pln_workorder_partlst)
	affw, err := e.Table("pln_workorder_partlst").ID(core.PK{G_FINR, t.Workordernr, t.Partid}).Count(woptab)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = e.Table("pln_workorder_partlst").Insert(t)

	if err != nil {
		return err
	}
	return nil
}

//增
func (t *Pln_workorder_partlst) Insert(session *xorm.Session) error {
	woptab := new(Pln_workorder_partlst)
	affw, err := session.Table("pln_workorder_partlst").ID(core.PK{G_FINR, t.Workordernr, t.Partid}).Count(woptab)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = session.Table("pln_workorder_partlst").Insert(t)

	if err != nil {
		return err
	}
	return nil
}

//删
func (t *Pln_workorder_partlst) Del() bool {
	e := G_DbEngine
	_, err := e.ID(core.PK{G_FINR, t.Workordernr, t.Partid}).Delete(&Pln_workorder_partlst{})
	if err != nil {
		return false
	}
	return true
}

//改
func (t *Pln_workorder_partlst) Update() bool {
	e := G_DbEngine
	_, err := e.ID(core.PK{G_FINR, t.Workordernr, t.Partid}).Update(t)
	if err != nil {
		return false
	}
	return true
}

//查
func (t *Pln_workorder_partlst) SelectOne() (data Pln_workorder_partlst, err error) {
	e := G_DbEngine
	_, err = e.ID(core.PK{G_FINR, t.Workordernr, t.Partid}).Get(&data)
	if err != nil {
		return data, err
	}
	return data, nil
}
