package db

import (
	"errors"
	"github.com/go-xorm/xorm"
	"leit.com/leit_seat_aps/common"
	"xorm.io/core"
)

//生产包装单子项表
type Prod_packorder_itemlst struct {
	Finr          int    `xorm:"pk" json:"prod_packorder_itemlst.finr"`
	Packorderid   string `xorm:"pk" json:"prod_packorder_itemlst.packorderid"`
	Pos           int    `xorm:"pk" json:"prod_packorder_itemlst.pos"`
	Poscode       string `json:"prod_packorder_itemlst.poscode"`
	Oemseq        int    `json:"prod_packorder_itemlst.oemseq"`
	Seq           int    `json:"prod_packorder_itemlst.seq"` // 手动指定的排序信息
	Supplygroupid string `json:"prod_packorder_itemlst.supplygroupid"`
	Workordernr   string `json:"prod_packorder_itemlst.workordernr"`
	Status        int    `json:"prod_packorder_itemlst.status"`
	Planqty       int    `json:"prod_packorder_itemlst.planqty"`
	Actqty        int    `json:"prod_packorder_itemlst.actqty"`
	Lastmodif     string `json:"prod_packorder_itemlst.lastmodif"`
	Lastuser      string `json:"prod_packorder_itemlst.lastuser"`
	Credatuz      string `json:"prod_packorder_itemlst.credatuz"`
}

func (t *Prod_packorder_itemlst) Clipped() {
	common.TrimStruct(t, *t)
}

func (t *Prod_packorder_itemlst) TableName() string {
	return "prod_packorder_itemlst"
}

//增
func (t *Prod_packorder_itemlst) Add() error {
	e := G_DbEngine
	pkoitemtab := new(Prod_packorder_itemlst)
	affw, err := e.Table("prod_packorder_itemlst").ID(core.PK{G_FINR, t.Packorderid, t.Pos}).Count(pkoitemtab)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = e.Table("prod_packorder_itemlst").Insert(t)

	if err != nil {
		return err
	}
	return nil
}

//增
func (t *Prod_packorder_itemlst) Insert(session *xorm.Session) error {
	pkoitemtab := new(Prod_packorder_itemlst)
	affw, err := session.Table("prod_packorder_itemlst").ID(core.PK{G_FINR, t.Packorderid, t.Pos}).Count(pkoitemtab)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = session.Table("prod_packorder_itemlst").Insert(t)

	if err != nil {
		return err
	}
	return nil
}

//删
func (t *Prod_packorder_itemlst) Del() bool {
	e := G_DbEngine
	_, err := e.ID(core.PK{G_FINR, t.Packorderid, t.Pos}).Delete(&Prod_packorder_itemlst{})
	if err != nil {
		return false
	}
	return true
}

//改
func (t *Prod_packorder_itemlst) Update() bool {
	e := G_DbEngine
	_, err := e.ID(core.PK{G_FINR, t.Packorderid, t.Pos}).Update(t)
	if err != nil {
		return false
	}
	return true
}

//改
func (t *Prod_packorder_itemlst) UpdateBySession(session *xorm.Session) bool {
	_, err := session.ID(core.PK{G_FINR, t.Packorderid, t.Pos}).Update(t)
	if err != nil {
		return false
	}
	return true
}

//更新指定字段
func (t *Prod_packorder_itemlst) UpdateFields(session *xorm.Session, fields string) (err error) {
	if _, err = session.Table("prod_packorder_itemlst").ID(core.PK{G_FINR, t.Packorderid, t.Pos}).Cols(fields).Update(t); err != nil {
		return
	}
	return
}

//查
func (t *Prod_packorder_itemlst) SelectOne() (data Prod_packorder_itemlst, err error) {
	e := G_DbEngine
	_, err = e.ID(core.PK{G_FINR, t.Packorderid, t.Pos}).Get(&data)
	if err != nil {
		return data, err
	}

	return data, nil
}
