package db

import (
	"errors"
	"leit.com/leit_seat_aps/common"
	"xorm.io/core"
)

//生产包装类型表
type Prod_packtype struct {
	Finr       int    `xorm:"pk"`
	Packtypeid string `xorm:"pk"`
	Descr      string
	Projnr     string
	Length     float64
	Width      float64
	Sizeuom    string
	Weight     float64
	Weightuom  string
	Sortorder  string
	Verifyslot int
	Verifyrule string
	Lastmodif  string
	Lastuser   string
	Credatuz   string
}

func (t *Prod_packtype) Clipped() {
	common.TrimStruct(t, *t)
}

func (t *Prod_packtype) TableName() string {
	return "prod_packtype"
}

//增
func (t *Prod_packtype) Add() error {
	e := G_DbEngine
	pktyptab := new(Prod_packtype)
	affw, err := e.Table("prod_packtype").ID(core.PK{G_FINR, t.Packtypeid}).Count(pktyptab)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = e.Table("prod_packtype").Insert(t)

	if err != nil {
		return err
	}
	return nil
}

//删
func (t *Prod_packtype) Del() bool {
	e := G_DbEngine
	_, err := e.ID(core.PK{G_FINR, t.Packtypeid}).Delete(&Prod_packtype{})
	if err != nil {
		return false
	}
	return true
}

//改
func (t *Prod_packtype) Update() bool {
	e := G_DbEngine
	_, err := e.ID(core.PK{G_FINR, t.Packtypeid}).Update(t)
	if err != nil {
		return false
	}
	return true
}

//查
func (t *Prod_packtype) SelectOne() (data Prod_packtype, err error) {
	e := G_DbEngine
	_, err = e.ID(core.PK{G_FINR, t.Packtypeid}).Get(&data)
	if err != nil {
		return data, err
	}
	data.Clipped()

	return data, nil
}

// 获取指定项目的生产包装类型列表
func (t *Prod_packtype) GetProjectAll(projnr string) (datalst []Prod_packtype, err error) {
	var i int

	e := G_DbEngine
	if err = e.Where("finr = ? and projnr = ?", G_FINR, projnr).OrderBy("packtypeid").Find(&datalst); err != nil {
		return
	}

	// 遍历属性获取属性值列表
	for i, _ = range datalst {
		datalst[i].Clipped()
	}
	return
}
