package db

import (
	"errors"
	"github.com/go-xorm/xorm"
	"leit.com/leit_seat_aps/common"
	"xorm.io/core"
)

// 项目对象
type Prod_project struct {
	Finr                            int    `xorm:"pk"`
	Projectid                       string `xorm:"pk"`
	Descr                           string
	Enabled                         int
	Plantsitecode                   int
	Emailserver_host                string
	Emailserver_port                int
	From_email                      string
	From_pwd                        string
	Mesmsg_snr                      string
	Prodpack_snr                    string
	Prodpacksync_snr                string
	Startoemseq						int
	Endoemseq						int
	Lastmodif                       string
	Lastuser                        string
	Credatuz                        string
}

func (t *Prod_project) Clipped() {
	common.TrimStruct(t, *t)
}

func (t *Prod_project) TableName() string {
	return "prod_project"
}

//增
func (t *Prod_project) Add() error {
	e := G_DbEngine
	projtab := new(Me_project)
	affw, err := e.Table("prod_project").ID(core.PK{G_FINR, t.Projectid}).Count(projtab)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = e.Table("prod_project").Insert(t)

	if err != nil {
		return err
	}
	return nil
}

//删
func (t *Prod_project) Del() bool {
	e := G_DbEngine
	_, err := e.ID(core.PK{G_FINR, t.Projectid}).Delete(&Prod_project{})
	if err != nil {
		return false
	}
	return true
}

//改
func (t *Prod_project) Update() bool {
	e := G_DbEngine
	_, err := e.ID(core.PK{G_FINR, t.Projectid}).Update(t)
	if err != nil {
		return false
	}
	return true
}

//查
func (t *Prod_project) SelectOne() (data Prod_project, err error) {
	e := G_DbEngine
	_, err = e.ID(core.PK{G_FINR, t.Projectid}).Get(&data)
	if err != nil {
		return data, err
	}
	return data, nil
}

//查
func (t *Prod_project) SelectOneBySession(session *xorm.Session, ) (data Prod_project, err error) {
	_, err = session.ID(core.PK{G_FINR, t.Projectid}).Get(&data)
	if err != nil {
		return data, err
	}
	return data, nil
}

//获取所有激活的项目数据
func (t *Prod_project) GetAllActive() (datalst []Prod_project, err error) {
	e := G_DbEngine
	if err = e.Where("finr = ? and enabled = ?", G_FINR, 1).OrderBy("projectid").Find(&datalst); err != nil {
		return
	}
	for i, _ := range datalst {
		datalst[i].Clipped()
	}
	return
}
