package db

import "leit.com/leit_seat_aps/common"

// 序列号对象
type Snrtab struct {
	Finr             int    `xorm:"pk"`
	Snrid            string `xorm:"pk"`
	Descr            string
	Validfrom        string
	Validto          string
	Prefix           string // 前缀
	Infix            string // 中缀
	Postfix          string // 后缀
	Startnr          int    // 流水号起始值
	Endnr            int    // 流水号结束值
	Step             int    // 步幅
	Length           int    // 长度
	Nextnr           int    // 下一流水号
	Lastnrcreate     string // 上一个流水号创建时间
	Resetnrrule      string // 重置流水号规则
	Overflowhandling string // 流水号溢出处理
	Identifierformat string // 流水号格式
	Datevariable     string // 日期变量
	Dateformat       string // 日期格式
	Identifierlayout string // 标识符布局
	Lastmodif        string
	Lastuser         string
	Credatuz         string
}

func (t *Snrtab) Clipped() {
	common.TrimStruct(t, *t)
}

func (t *Snrtab) TableName() string {
	return "snrtab"
}
