package db

import "leit.com/leit_seat_aps/common"

// 标准定义对象
type Stdeftab struct {
	Finr      int    `xorm:"pk"`
	Stdeftyp  string `xorm:"pk"`
	Statid    string `xorm:"pk"`
	Lang      string `xorm:"pk"`
	Bez       string
	Lastmodif string
	Lastuser  string
	Credatuz  string
}

func (t *Stdeftab) Clipped() {
	common.TrimStruct(t, *t)
}

func (t *Stdeftab) TableName() string {
	return "stdeftab"
}

// 获取指定标准的定义列表
func (t *Stdeftab) GetStandardList(stdtyp string) (datalst []Stdeftab, err error) {
	var i int
	e := G_DbEngine
	if err = e.Where("finr = ? and stdeftyp = ?", G_FINR, stdtyp).OrderBy("statid").Find(&datalst); err != nil {
		return
	}

	for i, _ = range datalst {
		datalst[i].Clipped()
	}
	return
}
