package db

import (
	"errors"
	"github.com/go-xorm/xorm"
	"leit.com/leit_seat_aps/common"
	"xorm.io/core"
)

//订单消息表
type Xml_msg struct {
	Finr        int    `xorm:"pk"`
	Msgid       string `xorm:"pk"`
	Msgtype     string
	Status      int
	Msg     	string
	Lastmodif   string
	Lastuser    string
	Credatuz    string
}

func (t *Xml_msg) Clipped() {
	common.TrimStruct(t, *t)
}
func (t *Xml_msg) TableName() string {
	return "xml_msg"
}

//增
func (t *Xml_msg) Add() error {
	e := G_DbEngine
	xmlmsgtab := new(Xml_msg)
	affw, err := e.Table("xml_msg").ID(core.PK{G_FINR, t.Msgid}).Count(xmlmsgtab)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = e.Table("xml_msg").Insert(t)

	if err != nil {
		return err
	}
	return nil
}

//增
func (t *Xml_msg) Insert(session *xorm.Session) error {
	xmlmsgtab := new(Xml_msg)
	affw, err := session.Table("xml_msg").ID(core.PK{G_FINR, t.Msgid}).Count(xmlmsgtab)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = session.Table("xml_msg").Insert(t)

	if err != nil {
		return err
	}
	return nil
}

//删
func (t *Xml_msg) Del() bool {
	e := G_DbEngine
	_, err := e.ID(core.PK{G_FINR, t.Msgid}).Delete(&Xml_msg{})
	if err != nil {
		return false
	}
	return true
}

//改
func (t *Xml_msg) Update() bool {
	e := G_DbEngine
	_, err := e.ID(core.PK{G_FINR, t.Msgid}).Update(t)
	if err != nil {
		return false
	}
	return true
}

//更新指定字段
func (t *Xml_msg) UpdateFields(session *xorm.Session, fields string) (err error) {
	if _, err = session.Table("xml_msg").ID(core.PK{G_FINR, t.Msgid}).Cols(fields).Update(t); err != nil {
		return
	}
	return
}

//更新指定字段
func (t *Xml_msg) UpdateFieldsWithoutSession(fields string) (err error) {
	e := G_DbEngine
	if _, err = e.Table("xml_msg").ID(core.PK{G_FINR, t.Msgid}).Cols(fields).Update(t); err != nil {
		return
	}
	return
}

//查
func (t *Xml_msg) SelectOne() (data Xml_msg, err error) {
	e := G_DbEngine
	_, err = e.ID(core.PK{G_FINR, t.Msgid}).Get(&data)
	if err != nil {
		return data, err
	}
	return data, nil
}

//获取没有生成xml的消息
func (t *Xml_msg) GetUnXmlMessages() (datalst []Xml_msg, err error) {
	var i int

	e := G_DbEngine
	if err = e.Where("finr = ? and msgtype = ? and status <= ?", G_FINR, common.MSG_TYPE_SHIP, common.MSG_STATUS_PLAN).OrderBy("credatuz").Find(&datalst); err != nil {
		return
	}
	for i = 0; i < len(datalst); i++ {
		datalst[i].Clipped()
	}
	return
}
