package seq

import (
	"fmt"
	"leit.com/leit_seat_aps/db"
	"testing"
)

// 测试车型生成服务
func TestRunCarmodelParser(t *testing.T) {
	var (
		connstring string
		err        error
	)

	// 连接数据库
	connstring = fmt.Sprintf("server=%s;user id=%s;password=%s;database=%s;port=%d;encrypt=disable",
		`DESKTOP-S4G95G5\\MLINK`, "lapp", "123fis", "LAPP_JITS", 1433)
	if err = db.InitMssqlDb(connstring); err != nil {
		t.Errorf("Failed to connect db due to: %v", err)
		return
	}
	defer db.G_DbEngine.Close()

	// 运行拣料服务
	if err = RunCarmodelParser("G38"); err != nil {
		t.Errorf("Failed to RunCarmodelParser due to: %v", err)
		return
	}

	return
}
