package service

import "leit.com/leit_seat_aps/db"

// 获取系统字符参数值: 模块 / 用户 / 参数名
func GetSysStringParameter(imodule int, user string, paraname string) (retval string, err error) {
	var (
		spatab    db.Spatab
		spatablst []db.Spatab
	)

	spatab = db.Spatab{}
	if spatablst, err = spatab.SelectByModuleUserParaname(imodule, user, paraname); err != nil {
		return
	}
	if len(spatablst) > 0 {
		retval = spatablst[0].Wertstring
	} else {
		retval = ""
	}

	return
}

// 获取系统整型参数值: 模块 / 用户 / 参数名
func GetSysIntParameter(imodule int, user string, paraname string) (retval int, err error) {
	var (
		spatab    db.Spatab
		spatablst []db.Spatab
	)

	spatab = db.Spatab{}
	if spatablst, err = spatab.SelectByModuleUserParaname(imodule, user, paraname); err != nil {
		return
	}
	if len(spatablst) > 0 {
		retval = spatablst[0].Wertnum
	} else {
		retval = 0
	}

	return
}
