package service

import (
	"github.com/go-xorm/xorm"
	"leit.com/leit_seat_aps/common"
	"leit.com/leit_seat_aps/db"
	"time"
)

// 订单消息服务，包括拣料单、包装单和发运单
type BL_Xmlmsg struct {
	MsgType   string // 消息类型，PICK 拣料单 PACK 包装单 SHIP 发运单
	Msg string
	Status int
	Xmlmsgtab db.Xml_msg
}

// 创建订单消息
func (bl_xmlmsg *BL_Xmlmsg) Create(session *xorm.Session) (err error) {
	var (
		//ordsn, prnsn string
		msgid        string
		xmlmsgtab    db.Xml_msg
	)

	//// 获取拣料单序列号
	//if ordsn, err = GetSysStringParameter(1, "*", "ORDERMSG_SN"); err != nil {
	//	return
	//}
	//if strings.TrimSpace(ordsn) == "" {
	//	ordsn = "ORDERMSG" // 默认流水ID
	//}
	//
	//// 获取打印表单头流水号
	//if prnsn, err = GetSysStringParameter(1, "*", "PRNSHEETHEAD_SN"); err != nil {
	//	return
	//}
	//if strings.TrimSpace(prnsn) == "" {
	//	prnsn = "PRNSHEETHEAD" // 默认流水ID
	//}

	// 获取消息号
	if msgid, err = SN_SyncGetNextSnr(""); err != nil {
		return
	}

	// 创建订单消息并返回
	xmlmsgtab = db.Xml_msg{}
	xmlmsgtab.Finr = db.G_FINR
	xmlmsgtab.Msgid = msgid
	xmlmsgtab.Msgtype = bl_xmlmsg.MsgType
	xmlmsgtab.Status = common.MSG_STATUS_PLAN
	xmlmsgtab.Msg = bl_xmlmsg.Msg
	xmlmsgtab.Credatuz = common.Date(time.Now().Unix(), "YYYYMMDDHHmmss")
	xmlmsgtab.Lastmodif = common.Date(time.Now().Unix(), "YYYYMMDDHHmmss")
	xmlmsgtab.Lastuser = "service"
	if err = xmlmsgtab.Insert(session); err != nil {
		return
	}
	return
}